Index: res/res_rtp_asterisk.c
===================================================================
--- res/res_rtp_asterisk.c	(.../branches/11)	(revision 385989)
+++ res/res_rtp_asterisk.c	(.../team/oej/pinefrog-rtcp-11)	(revision 385989)
@@ -3395,12 +3646,31 @@
 		ast_clear_flag(rtp, FLAG_NEED_MARKER_BIT);
 	}
 
+	/* Calculate timestamp for reception of the packet */
+	timestamp = ntohl(rtpheader[1]);
+	calc_rxstamp(&rxtime, rtp, timestamp, mark);
+
+	ast_format_copy(&bridged->lasttxformat, ast_rtp_codecs_get_payload_format(ast_rtp_instance_get_codecs(instance1), bridged_payload));
+	ast_format_copy(&rtp->lastrxformat, ast_rtp_codecs_get_payload_format(ast_rtp_instance_get_codecs(instance1), bridged_payload));
+
+ 	rate = rtp_get_rate(&rtp->lastrxformat) / 1000;
+
+	/* Now, calculate tx timestamp */
+	ms = calc_txstamp(rtp, &rxtime);
+	if (bridged_payload == AST_FRAME_VOICE) {
+		bridged->lastts = bridged->lastts + ms * rate;
+	} else if (bridged_payload == AST_FRAME_VIDEO) {
+		bridged->lastts = bridged->lastts + ms * 90;
+		/* This is not exact, but a best effort example that can be improved */
+	}
+
 	/* Reconstruct part of the packet */
 	reconstruct &= 0xFF80FFFF;
 	reconstruct |= (bridged_payload << 16);
 	reconstruct |= (mark << 23);
 	rtpheader[0] = htonl(reconstruct);
 
+
 	ast_rtp_instance_get_remote_address(instance1, &remote_address);
 
 	if (ast_sockaddr_isnull(&remote_address)) {
@@ -3428,6 +3698,9 @@
 		return 0;
 	}
 
+	bridged->txcount++;
+	bridged->txoctetcount += (res - hdrlen);
+
 	update_address_with_ice_candidate(rtp, COMPONENT_RTP, &remote_address);
 
 	if (rtp_debug_test_addr(&remote_address)) {
@@ -3483,7 +3756,7 @@
 
 	/* Make sure the data that was read in is actually enough to make up an RTP packet */
 	if (res < hdrlen) {
-		ast_log(LOG_WARNING, "RTP Read too short\n");
+		ast_log(LOG_WARNING, "RTP Read too short (%d expecting %d)\n", res, hdrlen);
 		return &ast_null_frame;
 	}
 
@@ -3573,10 +3846,6 @@
 		}
 	}
 
-	/* If we are directly bridged to another instance send the audio directly out */
-	if (ast_rtp_instance_get_bridged(instance) && !bridge_p2p_rtp_write(instance, rtpheader, res, hdrlen)) {
-		return &ast_null_frame;
-	}
 
 	/* If the version is not what we expected by this point then just drop the packet */
 	if (version != 2) {
@@ -3617,6 +3886,15 @@
 
 	rtp->rxssrc = ssrc;
 
+	/* Schedule RTCP report transmissions if possible */
+	ast_rtcp_schedule(instance);
+
+	/* This needs to be after RTCP calculations to get more RTCP data */
+	/* If we are directly bridged to another instance send the audio directly out */
+	if (ast_rtp_instance_get_bridged(instance) && !bridge_p2p_rtp_write(instance, rtpheader, res, hdrlen)) {
+		return &ast_null_frame;
+	}
+
 	/* Remove any padding bytes that may be present */
 	if (padding) {
 		res -= rtp->rawdata[AST_FRIENDLY_OFFSET + res - 1];
@@ -4065,6 +4343,45 @@
 	AST_RTP_STAT_SET(AST_RTP_INSTANCE_STAT_LOCAL_SSRC, -1, stats->local_ssrc, rtp->ssrc);
 	AST_RTP_STAT_SET(AST_RTP_INSTANCE_STAT_REMOTE_SSRC, -1, stats->remote_ssrc, rtp->themssrc);
 
+	AST_RTP_STAT_SET(AST_RTP_INSTANCE_STAT_START, -1, stats->start, rtp->start);
+	if (stat == AST_RTP_INSTANCE_STAT_IP || stat == AST_RTP_INSTANCE_STAT_ALL) {
+		memcpy(&stats->them, &rtp->rtcp->them, sizeof(stats->them));
+	}
+	if (stat == AST_RTP_INSTANCE_STAT_LOCAL_CNAME || stat == AST_RTP_INSTANCE_STAT_ALL) {
+		memcpy(&stats->ourcname, &rtp->rtcp->ourcname, rtp->rtcp->ourcnamelength);	/* UTF8 safe */
+		stats->ourcnamelength = rtp->rtcp->ourcnamelength;
+	}
+	if (stat == AST_RTP_INSTANCE_STAT_REMOTE_CNAME || stat == AST_RTP_INSTANCE_STAT_ALL) {
+		memcpy(&stats->theircname, &rtp->rtcp->theircname, rtp->rtcp->theircnamelength);	/* UTF8 safe */
+		stats->theircnamelength = rtp->rtcp->theircnamelength;
+	}
+
+	/* To fix */
+	stats->readcost = rtp->rtcp->readcost;
+        stats->writecost = rtp->rtcp->writecost;
+	stats->lasttxformat = rtp->lasttxformat;
+	stats->lastrxformat = rtp->lastrxformat;
+	if (!ast_strlen_zero(rtp->rtcp->readtranslator)) {
+		ast_copy_string(stats->readtranslator, rtp->rtcp->readtranslator, sizeof(stats->readtranslator));
+	}
+	if (!ast_strlen_zero(rtp->rtcp->writetranslator)) {
+		ast_copy_string(stats->writetranslator, rtp->rtcp->writetranslator, sizeof(stats->writetranslator));
+	}
+	if (!ast_strlen_zero(rtp->rtcp->readtranslator)) {
+		ast_copy_string(stats->readtranslator, rtp->rtcp->readtranslator, sizeof(stats->readtranslator));
+	}
+	if (!ast_strlen_zero(rtp->rtcp->channel)) {
+		ast_copy_string(stats->channel, rtp->rtcp->channel, sizeof(stats->channel));
+	}
+	if (!ast_strlen_zero(rtp->rtcp->bridgedchannel)) {
+		ast_copy_string(stats->bridgedchannel, rtp->rtcp->bridgedchannel, sizeof(stats->bridgedchannel));
+	}
+	if (!ast_strlen_zero(rtp->rtcp->uniqueid)) {
+		ast_copy_string(stats->uniqueid, rtp->rtcp->uniqueid, sizeof(stats->uniqueid));
+	}
+	if (!ast_strlen_zero(rtp->rtcp->bridgeduniqueid)) {
+		ast_copy_string(stats->bridgeduniqueid, rtp->rtcp->bridgeduniqueid, sizeof(stats->bridgeduniqueid));
+	}
 	return 0;
 }
 
@@ -4094,11 +4411,36 @@
 	ast_sockaddr_from_sin(suggestion, &suggestion_tmp);
 }
 
+/* \brief Put stream on/off hold, mute outbound RTP but keep
+	RTP keepalives and RTCP going
+ */
+static void ast_rtp_hold(struct ast_rtp_instance *instance, int status)
+{
+	struct ast_rtp *rtp = ast_rtp_instance_get_data(instance);
+	if (status) {
+		ast_debug(3, "##### HOLDING RTCP, Have a nice silent day \n");
+		ast_set_flag(rtp, FLAG_HOLD);
+	} else {
+		ast_debug(3, "##### UNHOLDING RTCP, You will get audio now. \n");
+		ast_clear_flag(rtp, FLAG_HOLD);
+	}
+}
+
+/*! \brief STOP the media streams, END the session. 
+	Note: This is not hold. This is shutting down all the fun.
+*/
 static void ast_rtp_stop(struct ast_rtp_instance *instance)
 {
 	struct ast_rtp *rtp = ast_rtp_instance_get_data(instance);
 	struct ast_sockaddr addr = { {0,} };
 
+ 	ast_debug(3, "##### Stopping RTP, Sending good bye and cleaning up.\n");
+ 
+ 	/* Send RTCP goodbye packet */
+ 	if (rtp->isactive && rtp->rtcp) {
+ 		ast_rtcp_write_sr(instance, 1);
+ 	}
+
 #ifdef HAVE_OPENSSL_SRTP
 	AST_SCHED_DEL_UNREF(rtp->sched, rtp->rekeyid, ao2_ref(instance, -1));
 #endif
@@ -4123,6 +4465,7 @@
 	}
 
 	ast_set_flag(rtp, FLAG_NEED_MARKER_BIT);
+	rtp->isactive = 0;
 }
 
 static int ast_rtp_qos_set(struct ast_rtp_instance *instance, int tos, int cos, const char *desc)
@@ -4132,6 +4475,91 @@
 	return ast_set_qos(rtp->s, tos, cos, desc);
 }
 
+
+/*! \brief set RTP cname used to describe session in RTCP sdes messages */
+void ast_rtcp_setcname(struct ast_rtp_instance *instance, const char *cname, size_t length)
+{
+	struct ast_rtp *rtp = ast_rtp_instance_get_data(instance);
+
+	if (!rtp || !rtp->rtcp) {
+		return;
+	}
+	if (length > 255) {
+		length=255;
+	}
+	ast_copy_string(rtp->rtcp->ourcname, cname, length+1);
+	rtp->rtcp->ourcnamelength = length;
+	if (option_debug > 3) {
+		ast_log(LOG_DEBUG, "--- Copied CNAME %s to RTCP structure (length %d)\n", cname, (int) length);
+	}
+}
+
+/*! \brief set the name of the bridged channel
+
+At the time when we write the report there might not be a bridge, so we need
+to store this so we can correlate the reports. If a channel changes bridge,
+it can be reset by first setting it to an empty string, then setting to 
+a new name 
+*/
+void ast_rtcp_set_bridged(struct ast_rtp_instance *instance, const char *channel, const char *uniqueid, const char *bridgedchan, const char *bridgeduniqueid)
+{
+	struct ast_rtp *rtp = ast_rtp_instance_get_data(instance);
+
+	if (!rtp) {		/* For some reason, there's no RTP */
+		ast_debug(1, "??????????????? NO RTP \n");
+		return;
+	}
+	if (!rtp->rtcp) {	/* No RTCP? Strange */
+		ast_debug(1, "??????????????? NO RTCP \n");
+		return;
+	}
+	/* If we already have data, don't replace it. 
+		NOTE: Should we replace it at a masquerade or something? Hmm.
+	*/
+	if (!ast_strlen_zero(channel) && !rtp->rtcp->channel[0]) {
+		ast_debug(1, "!!!!!! Setting channel name to %s\n", channel);
+		ast_copy_string(rtp->rtcp->channel, channel, sizeof(rtp->rtcp->channel));
+	}
+	if (!ast_strlen_zero(uniqueid) && !rtp->rtcp->uniqueid[0]) {
+		ast_debug(1, "!!!!!! Setting unique id to %s\n", uniqueid);
+		ast_copy_string(rtp->rtcp->uniqueid, uniqueid, sizeof(rtp->rtcp->uniqueid));
+	}
+	if (!ast_strlen_zero(bridgedchan)) {
+		ast_debug(1, "!!!!!! Setting bridged channel name to %s\n", bridgedchan);
+		ast_copy_string(rtp->rtcp->bridgedchannel, bridgedchan, sizeof(rtp->rtcp->bridgedchannel));
+	} else {
+		if(rtp->rtcp->bridgedchannel[0] != '\0') {
+			ast_debug(1, "!!!!!! Keeping bridged channel name %s\n", rtp->rtcp->bridgedchannel);
+		}
+		//rtp->rtcp->bridgedchan[0] = '\0';
+	}
+	if (!ast_strlen_zero(bridgeduniqueid)) {
+		ast_debug(1, "!!!!!! Setting bridged unique id to %s\n", bridgeduniqueid);
+		ast_copy_string(rtp->rtcp->bridgeduniqueid, bridgeduniqueid, sizeof(rtp->rtcp->bridgeduniqueid));
+	} else {
+		if(rtp->rtcp->bridgeduniqueid[0] != '\0') {
+			ast_debug(1, "!!!!!! Keeping bridged unique id \n");
+		}
+	}
+}
+
+
+/*! \brief Set the transcoding variables for the QoS reports */
+void ast_rtcp_set_translator(struct ast_rtp_instance *instance, const char *readtranslator, const int readcost, const char *writetranslator, const int writecost)
+{
+	struct ast_rtp *rtp = ast_rtp_instance_get_data(instance);
+	if (!rtp || !rtp->rtcp) {
+		return;
+	}
+	ast_copy_string(rtp->rtcp->readtranslator, S_OR(readtranslator,""), sizeof(rtp->rtcp->readtranslator));
+	ast_copy_string(rtp->rtcp->writetranslator, S_OR(writetranslator,""), sizeof(rtp->rtcp->writetranslator));
+	rtp->rtcp->readcost = readcost;
+	rtp->rtcp->writecost = writecost;
+	
+}
+
+
+
 /*! \brief generate comfort noice (CNG) */
 static int ast_rtp_sendcng(struct ast_rtp_instance *instance, int level)
 {
@@ -4199,6 +4627,120 @@
 }
 #endif
 
+/*! \brief Check if rtp stream is active */
+static int ast_rtp_isactive(struct ast_rtp_instance *instance)
+{
+	struct ast_rtp *rtp = ast_rtp_instance_get_data(instance);
+	return rtp->isactive ? 0 : 1;
+}
+
+/*! \brief Basically add SSRC */
+static int add_sdes_header(struct ast_rtp *rtp, unsigned int *rtcp_packet, int len)
+{
+	/* 2 is version, 1 is number of chunks, then RTCP packet type (SDES) and length */
+	*rtcp_packet = htonl((2 << 30) | (1 << 24) | (RTCP_PT_SDES << 16) | ((len/4)-1));
+
+	rtcp_packet++;	/* Move 32 bits ahead for the header */
+	*rtcp_packet = htonl(rtp->ssrc);               /* Our SSRC */
+	rtcp_packet ++;
+
+	/* Header + SSRC */
+	return len + 8;
+}
+
+static int add_sdes_bodypart(struct ast_rtp *rtp, unsigned int *rtcp_packet, int len, int type)
+{
+	int cnamelen;
+	int sdeslen = 0;
+	char *sdes;
+
+	sdes = (char *) rtcp_packet;
+	switch (type) {
+	case SDES_CNAME:
+		cnamelen = (int) rtp->rtcp->ourcnamelength;
+
+		*sdes = SDES_CNAME;
+		sdes++;
+		*sdes = (char) cnamelen;
+		sdes++;
+		strncpy(sdes, rtp->rtcp->ourcname, cnamelen);	/* NO terminating 0 */
+
+		/* THere must be a multiple of four bytes in the packet */
+		sdeslen = cnamelen;
+		break;
+	case SDES_END:
+		*sdes = SDES_END;
+		sdes++;
+		*sdes = (char) 0;
+		sdes++;
+		sdeslen = 2;
+	}
+	len += sdeslen + (sdeslen % 4 == 0 ? 0 : 4 - (sdeslen % 4)) ;
+
+	return len;
+}
+
+/*! \brief Send emtpy RTCP receiver's report and SDES message 
+ 	Mainly used to open NAT sessions  */
+static int ast_rtcp_write_empty_frame(struct ast_rtp_instance *instance)
+{
+	struct ast_rtp *rtp = ast_rtp_instance_get_data(instance);
+	char bdata[512];
+	unsigned int *rtcpheader, *start;
+	int fd, len, res;
+
+	if (!rtp || !rtp->rtcp) {
+		return 0;
+	} 
+	ast_debug(1,  "************ ---- About to send empty RTCP packet\n");
+	fd = rtp->rtcp->s;
+	
+	if (fd == -1) {
+		ast_debug(1, "--- No file descriptor to use \n");
+	}
+	
+	if (!ast_sockaddr_isnull(&rtp->rtcp->them)) { /* This'll stop rtcp for this rtp session */
+		ast_verbose("RTCP SR transmission error, rtcp halted\n");
+		AST_SCHED_DEL(rtp->sched, rtp->rtcp->schedid);
+		return 0;
+	}
+	if (rtcp_debug_test_addr(&rtp->rtcp->them)) {
+		ast_debug(1,  "---- About to send empty RTCP packet\n");
+	}
+	rtcpheader = (unsigned int *)bdata;
+	/* Add a RR header with no reports (chunks = 0) - The RFC says that it's always needed 
+		first in a compound packet.
+	 */
+	rtcpheader[0] = htonl((2 << 30) | (0 << 24) | (RTCP_PT_RR << 16) | 1);
+	rtcpheader[1] = htonl(rtp->ssrc);
+	len = 8;
+	start = &rtcpheader[len/4];
+	len +=8; /* SKip header for now */
+	len = add_sdes_bodypart(rtp, &rtcpheader[len/4], len, SDES_CNAME);
+	len = add_sdes_bodypart(rtp, &rtcpheader[len/4], len, SDES_END);
+	/* Now, add header when we know the actual length */
+	add_sdes_header(rtp, start, len);
+
+	res = sendto(fd, (unsigned int *)rtcpheader, len, 0, (struct sockaddr *)&rtp->rtcp->them, sizeof(rtp->rtcp->them));
+
+	if (res < 0) {
+		ast_log(LOG_ERROR, "RTCP RR transmission error, rtcp halted: %s\n",strerror(errno));
+		/* Remove the scheduler */
+		AST_SCHED_DEL(rtp->sched, rtp->rtcp->schedid);
+		return 0;
+	}
+
+	rtp->rtcp->rr_count++;
+
+	if (rtcp_debug_test_addr(&rtp->rtcp->them)) {
+		ast_verbose("\n* Sending Empty RTCP RR to %s  Our SSRC: %u\n",
+			ast_sockaddr_stringify(&rtp->rtcp->them),
+			rtp->ssrc);
+	}
+
+	return res;
+}
+
 static char *rtp_do_debug_ip(struct ast_cli_args *a)
 {
 	char *arg = ast_strdupa(a->argv[4]);
@@ -4210,8 +4752,7 @@
 		return CLI_FAILURE;
 	}
 	rtpdebugport = (!ast_strlen_zero(debugport) && debugport[0] != '0');
-	ast_cli(a->fd, "RTP Debugging Enabled for address: %s\n",
-		ast_sockaddr_stringify(&rtpdebugaddr));
+	ast_cli(a->fd, "RTP Debugging Enabled for address: %s\n", ast_sockaddr_stringify(&rtpdebugaddr));
 	rtpdebug = 1;
 	return CLI_SUCCESS;
 }
Index: res/res_mutestream.c
===================================================================
--- res/res_mutestream.c	(.../branches/11)	(revision 385989)
+++ res/res_mutestream.c	(.../team/oej/pinefrog-rtcp-11)	(revision 385989)
@@ -35,7 +35,7 @@
 
 #include "asterisk.h"
 
-ASTERISK_FILE_VERSION(__FILE__, "$Revision$")
+ASTERISK_FILE_VERSION(__FILE__, "$Revision: 89545 $")
 
 #include "asterisk/options.h"
 #include "asterisk/logger.h"

Index: res/res_xmpp.c
===================================================================
--- res/res_xmpp.c	(.../branches/11)	(revision 385989)
+++ res/res_xmpp.c	(.../team/oej/pinefrog-rtcp-11)	(revision 385989)
@@ -700,10 +700,10 @@
 /*! \brief Comparator function for XMPP resource */
 static int xmpp_resource_cmp(void *obj, void *arg, int flags)
 {
-	struct ast_xmpp_resource *resource1 = obj;
+	struct ast_xmpp_resource *resource1 = obj, *resource2 = arg;
 	const char *resource = arg;
 
-	return !strcmp(resource1->resource, resource) ? CMP_MATCH | CMP_STOP : 0;
+	return !strcmp(resource1->resource, flags & OBJ_KEY ? resource : resource2->resource) ? CMP_MATCH | CMP_STOP : 0;
 }
 
 /*! \brief Destructor callback function for XMPP buddy */
@@ -1328,15 +1328,14 @@
 		return IKS_FILTER_EAT;
 	}
 	if (!strcasecmp(iks_name(item_content), "state")) {
-		if ((cachable_str = iks_find_attrib(item_content, "cachable"))) {
+		device_state = iks_find_cdata(item, "state");
+		if ((cachable_str = iks_find_cdata(item, "cachable"))) {
 			sscanf(cachable_str, "%30d", &cachable);
 		}
-		device_state = iks_find_cdata(item, "state");
 		if (!(event = ast_event_new(AST_EVENT_DEVICE_STATE_CHANGE,
 					    AST_EVENT_IE_DEVICE, AST_EVENT_IE_PLTYPE_STR, item_id, AST_EVENT_IE_STATE,
 					    AST_EVENT_IE_PLTYPE_UINT, ast_devstate_val(device_state), AST_EVENT_IE_EID,
 					    AST_EVENT_IE_PLTYPE_RAW, &pubsub_eid, sizeof(pubsub_eid),
-					    AST_EVENT_IE_CACHABLE, AST_EVENT_IE_PLTYPE_UINT, cachable,
 					    AST_EVENT_IE_END))) {
 			return IKS_FILTER_EAT;
 		}
@@ -1546,7 +1545,7 @@
 		return -1;
 	}
 
-	if (ast_strlen_zero(jid.resource) || !(resource = ao2_callback(buddy->resources, 0, xmpp_resource_cmp, jid.resource))) {
+	if (ast_strlen_zero(jid.resource) || !(resource = ao2_find(buddy->resources, jid.resource, OBJ_KEY))) {
 		resource = ao2_callback(buddy->resources, OBJ_NODATA, xmpp_resource_immediate, NULL);
 	}
 
@@ -1617,7 +1616,7 @@
 		return -1;
 	}
 
-	if (ast_strlen_zero(jid.resource) || !(resource = ao2_callback(buddy->resources, 0, xmpp_resource_cmp, jid.resource))) {
+	if (ast_strlen_zero(jid.resource) || !(resource = ao2_find(buddy->resources, jid.resource, OBJ_KEY))) {
 		resource = ao2_callback(buddy->resources, OBJ_NODATA, xmpp_resource_immediate, NULL);
 	}
 
@@ -2345,7 +2344,7 @@
 		return IKS_FILTER_EAT;
 	}
 
-	if (!(resource = ao2_callback(buddy->resources, 0, xmpp_resource_cmp, pak->from->resource))) {
+	if (!(resource = ao2_find(buddy->resources, pak->from->resource, OBJ_KEY))) {
 		ao2_ref(buddy, -1);
 		return IKS_FILTER_EAT;
 	}
@@ -3138,7 +3137,7 @@
 
 	ao2_lock(buddy->resources);
 
-	if (!(resource = ao2_callback(buddy->resources, OBJ_NOLOCK, xmpp_resource_cmp, pak->from->resource))) {
+	if (!(resource = ao2_find(buddy->resources, pak->from->resource, OBJ_KEY | OBJ_NOLOCK))) {
 		/* Only create the new resource if it is not going away - in reality this should not happen */
 		if (status != STATUS_DISAPPEAR) {
 			if (!(resource = ao2_alloc(sizeof(*resource), xmpp_resource_destructor))) {
@@ -3637,8 +3636,8 @@
 			cfg->client->jid = iks_id_new(cfg->client->stack, cfg->user);
 		}
 
-		if (!cfg->client->jid || ast_strlen_zero(cfg->client->jid->user)) {
-			ast_log(LOG_ERROR, "Jabber identity '%s' could not be created for client '%s' - client not active\n", cfg->user, cfg->name);
+		if (!cfg->client->jid) {
+			ast_log(LOG_ERROR, "Jabber identity could not be created for client '%s' - client not active\n", cfg->name);
 			return -1;
 		}
 
Index: res/res_jabber.c
===================================================================
--- res/res_jabber.c	(.../branches/11)	(revision 385989)
+++ res/res_jabber.c	(.../team/oej/pinefrog-rtcp-11)	(revision 385989)
@@ -3339,15 +3339,14 @@
 		return IKS_FILTER_EAT;
 	}
 	if (!strcasecmp(iks_name(item_content), "state")) {
-		if ((cachable_str = iks_find_attrib(item_content, "cachable"))) {
+		device_state = iks_find_cdata(item, "state");
+		if ((cachable_str = iks_find_cdata(item, "cachable"))) {
 			sscanf(cachable_str, "%30d", &cachable);
 		}
-		device_state = iks_find_cdata(item, "state");
 		if (!(event = ast_event_new(AST_EVENT_DEVICE_STATE_CHANGE,
 					    AST_EVENT_IE_DEVICE, AST_EVENT_IE_PLTYPE_STR, item_id, AST_EVENT_IE_STATE,
 					    AST_EVENT_IE_PLTYPE_UINT, ast_devstate_val(device_state), AST_EVENT_IE_EID,
 					    AST_EVENT_IE_PLTYPE_RAW, &pubsub_eid, sizeof(pubsub_eid),
-					    AST_EVENT_IE_CACHABLE, AST_EVENT_IE_PLTYPE_UINT, cachable,
 					    AST_EVENT_IE_END))) {
 			return IKS_FILTER_EAT;
 		}
Index: res/res_config_curl.c
===================================================================
--- res/res_config_curl.c	(.../branches/11)	(revision 385989)
+++ res/res_config_curl.c	(.../team/oej/pinefrog-rtcp-11)	(revision 385989)
@@ -463,7 +463,7 @@
 {
 	struct ast_str *query, *buffer;
 	char *elm, field[256];
-	int type, size, i = 0;
+	int type, size;
 
 	if (!ast_custom_function_find("CURL")) {
 		ast_log(LOG_ERROR, "func_curl.so must be loaded in order to use res_config_curl.so!!\n");
@@ -484,9 +484,7 @@
 		type = va_arg(ap, require_type);
 		size = va_arg(ap, int);
 		ast_uri_encode(elm, field, sizeof(field), ast_uri_http);
-		ast_str_append(&query, 0, "%s%s=%s%%3A%d",
-			i > 0 ? "&" : "",
-			field,
+		ast_str_append(&query, 0, "%s=%s%%3A%d", field,
 			type == RQ_CHAR ? "char" :
 			type == RQ_INTEGER1 ? "integer1" :
 			type == RQ_UINTEGER1 ? "uinteger1" :
@@ -502,7 +500,6 @@
 			type == RQ_DATETIME ? "datetime" :
 			type == RQ_FLOAT ? "float" :
 			"unknown", size);
-		i++;
 	}
 
 	ast_str_append(&query, 0, ")}");
Index: codecs/codec_resample.c
===================================================================
--- codecs/codec_resample.c	(.../branches/11)	(revision 385989)
+++ codecs/codec_resample.c	(.../team/oej/pinefrog-rtcp-11)	(revision 385989)
@@ -113,7 +113,7 @@
 	int res = 0;
 	int x, y, idx = 0;
 
-	trans_size = ARRAY_LEN(id_list) * (ARRAY_LEN(id_list) - 1);
+	trans_size = ARRAY_LEN(id_list) * ARRAY_LEN(id_list);
 	if (!(translators = ast_calloc(1, sizeof(struct ast_translator) * trans_size))) {
 		return AST_MODULE_LOAD_FAILURE;
 	}
Index: codecs/Makefile
===================================================================
--- codecs/Makefile	(.../branches/11)	(revision 385989)
+++ codecs/Makefile	(.../team/oej/pinefrog-rtcp-11)	(revision 385989)
@@ -53,8 +53,8 @@
 	for dir in $(SUB_DIRS); do \
 		$(MAKE) -C $$dir clean; \
 	done
-	rm -f g722/*.[oai]
-	rm -f speex/*.[oai]
+	rm -f g722/*.[oa]
+	rm -f speex/*.[oa]
 
 .PHONY: $(SUB_DIRS)
 
Index: contrib/realtime/postgresql/realtime.sql
===================================================================
--- contrib/realtime/postgresql/realtime.sql	(.../branches/11)	(revision 385989)
+++ contrib/realtime/postgresql/realtime.sql	(.../team/oej/pinefrog-rtcp-11)	(revision 385989)
@@ -39,7 +39,7 @@
 callerid character varying(80),
 canreinvite character varying(3) DEFAULT 'yes',
 context character varying(80),
-defaultip character varying(45),
+defaultip character varying(15),
 dtmfmode character varying(7),
 fromuser character varying(80),
 fromdomain character varying(80),
Index: contrib/realtime/mysql/sippeers.sql
===================================================================
--- contrib/realtime/mysql/sippeers.sql	(.../branches/11)	(revision 385989)
+++ contrib/realtime/mysql/sippeers.sql	(.../team/oej/pinefrog-rtcp-11)	(revision 385989)
@@ -5,19 +5,19 @@
 CREATE TABLE IF NOT EXISTS `sippeers` (
       `id` int(11) NOT NULL AUTO_INCREMENT,
       `name` varchar(10) NOT NULL,
-      `ipaddr` varchar(45) DEFAULT NULL,
+      `ipaddr` varchar(15) DEFAULT NULL,
       `port` int(5) DEFAULT NULL,
       `regseconds` int(11) DEFAULT NULL,
       `defaultuser` varchar(10) DEFAULT NULL,
-      `fullcontact` varchar(80) DEFAULT NULL,
+      `fullcontact` varchar(35) DEFAULT NULL,
       `regserver` varchar(20) DEFAULT NULL,
       `useragent` varchar(20) DEFAULT NULL,
       `lastms` int(11) DEFAULT NULL,
       `host` varchar(40) DEFAULT NULL,
       `type` enum('friend','user','peer') DEFAULT NULL,
       `context` varchar(40) DEFAULT NULL,
-      `permit` varchar(95) DEFAULT NULL,
-      `deny` varchar(95) DEFAULT NULL,
+      `permit` varchar(40) DEFAULT NULL,
+      `deny` varchar(40) DEFAULT NULL,
       `secret` varchar(40) DEFAULT NULL,
       `md5secret` varchar(40) DEFAULT NULL,
       `remotesecret` varchar(40) DEFAULT NULL,
@@ -56,7 +56,7 @@
       `fromdomain` varchar(40) DEFAULT NULL,
       `fromuser` varchar(40) DEFAULT NULL,
       `qualify` varchar(40) DEFAULT NULL,
-      `defaultip` varchar(45) DEFAULT NULL,
+      `defaultip` varchar(40) DEFAULT NULL,
       `rtptimeout` int(11) DEFAULT NULL,
       `rtpholdtimeout` int(11) DEFAULT NULL,
       `sendrpid` enum('yes','no') DEFAULT NULL,
@@ -66,8 +66,8 @@
       `timerb` int(11) DEFAULT NULL,
       `qualifyfreq` int(11) DEFAULT NULL,
       `constantssrc` enum('yes','no') DEFAULT NULL,
-      `contactpermit` varchar(95) DEFAULT NULL,
-      `contactdeny` varchar(95) DEFAULT NULL,
+      `contactpermit` varchar(40) DEFAULT NULL,
+      `contactdeny` varchar(40) DEFAULT NULL,
       `usereqphone` enum('yes','no') DEFAULT NULL,
       `textsupport` enum('yes','no') DEFAULT NULL,
       `faxdetect` enum('yes','no') DEFAULT NULL,
